# Setup PyCharm for QGIS & EnMAP-Box Programming

The following steps are a summary from: https://enmap-box.readthedocs.io/en/latest/dev_section/dev_installation.html

1. Make sure to have git, git lfs and PyCharm installed
2. Install conda (or mamba)  https://docs.conda.io/en/latest/miniconda.html
3. Create an environment (*qgis_stable*) with QGIS and other packages  
   
   ``$>conda env create --name qgis_stable --file https://bitbucket.org/hu-geomatics/enmap-box/raw/develop/conda_environment.yml``
   
   You can activate it by ``$>conda activate qgis_stable``

   and deactivate with ``$>(qgis_stable) conda deactivate``

   You can start QGIS by 
   
4. Goto ``<your conda folder>/envs/qgis_stable/etc/conda/activate.de`` and create a script that allows you to start PyCharm
   from the conda shell:
    
   Windows *pycharm-activate.bat*
   ````
   @echo off
   doskey pycharm="<path to local>\pycharm64.exe"
   ````
   
   Linux/macOS *pycharm-activate.sh*

   ````
   alias pycharm="<path to local>/pycharm"
   ````
   
5. Deactivate and activate *qgis_stable* again and start PyCharm: ``$>pycharm``
   
6. Create a new project:
   
    * use  ``<your conda folder>/envs/qgis_stable/python.exe`` as project interpreter

    * add ``<your conda folder>/envs/qgis_stable/Library/python`` as project content root
    
    * set ``<your conda folder>/envs/qgis_stable/Library/python/plugins`` as additional source folder


8. Clone and initialize the EnMAP-Box repository:
   
   ``
   $>(qgis_stable) cd <your repositories>
   $>(qgis_stable) git clone https://bitbucket.org/hu-geomatics/enmap-box.git
   $>python enmap-box/scripts/setup_repository.py
   
9. Add ``<your repositories>/enmap-box`` as content root to your Pycharm project
